diff --git a/books/bookvol9.pamphlet b/books/bookvol9.pamphlet
index 93f03d1..944c1ff 100644
--- a/books/bookvol9.pamphlet
+++ b/books/bookvol9.pamphlet
@@ -1158,13 +1158,11 @@ from the compiler stack {\tt \$compStack} and
 <<defun compOrCroak1,fn>>=
 (defun |compOrCroak1,fn| (x m e |$compStack| |$compErrorMessageStack| compFn)
  (declare (special |$compStack| |$compErrorMessageStack|))
- (prog (td errorMessage)
+ (let (td errorMessage)
   (declare (special |$level| |$s| |$scanIfTrue| |$exitModeStack|))
-   (return
-    (seq 
-     (if 
-      (setq td (catch '|compOrCroak| (funcall compFn x m e)))
-      (exit td))
+  (cond
+   ((setq td (catch '|compOrCroak| (funcall compFn x m e))) td)
+   (t
      (setq |$compStack| (cons (list x m e |$exitModeStack|) |$compStack|))
      (setq |$s| (|compOrCroak1,compactify| |$compStack|))
      (setq |$level| (|#| |$s|))
@@ -1172,20 +1170,21 @@ from the compiler stack {\tt \$compStack} and
        (if |$compErrorMessageStack|
          (car |$compErrorMessageStack|)
          '|unspecified error|))
-     (if |$scanIfTrue|
-      (exit 
-       (seq 
+     (cond 
+      (|$scanIfTrue|
         (|stackSemanticError| errorMessage (|mkErrorExpr| |$level|))
-        (exit (list '|failedCompilation| m e )))))
-     (|displaySemanticErrors|)
-     (say "****** comp fails at level " |$level| " with expression: ******")
-     (|displayComp| |$level|)
-     (exit (|userError| errorMessage))))))
+        (list '|failedCompilation| m e ))
+      (t
+       (|displaySemanticErrors|)
+       (say "****** comp fails at level " |$level| " with expression: ******")
+       (|displayComp| |$level|)
+       (|userError| errorMessage)))))))
 
 @
 
 \defun{compOrCroak1,compactify}{compOrCroak1,compactify}
 \calls{compOrCroak1,compactify}{compOrCroak1,compactify}
+\calls{compOrCroak1,compactify}{lassoc}
 <<defun compOrCroak1,compactify>>=
 (defun |compOrCroak1,compactify| (al)
  (cond
diff --git a/changelog b/changelog
index 9fda652..3146483 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20100830 tpd src/axiom-website/patches.html 20100830.02.tpd.patch
+20100830 tpd books/bookvol9 treeshake compiler
 20100830 tpd src/axiom-website/patches.html 20100830.01.tpd.patch
 20100830 tpd books/bookvolbib add Tim Lahey's Sage Integration Test Suite
 20100829 tpd src/axiom-website/patches.html 20100829.02.tpd.patch
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index cf51fe8..db7ae44 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -3095,5 +3095,7 @@ Makefile always run help extractions in parallel<br/>
 books/bookvol9 treeshake compiler<br/>
 <a href="patches/20100830.01.tpd.patch">20100830.01.tpd.patch</a>
 books/bookvolbib add Tim Lahey's Sage Integration Test Suite<br/>
+<a href="patches/20100830.02.tpd.patch">20100830.02.tpd.patch</a>
+books/bookvol9 treeshake compiler<br/>
  </body>
 </html>
